//////////////////////////////////////////////////////////////////////////
//                                                                      //
// atan2f.cpp -                                                          //
//                                                                      //
//                              //
//        .                          //
//                                                                      //
// Copyright (c) 2001 RC Module Inc.                                    //
//                                                                      //
//  :  ..                                                 //
//                                                                      //
//   $Revision:: 1     $      $Date:: 2/14/06 8:06p    $                //
//                                                                      //
//////////////////////////////////////////////////////////////////////////

#include "math.h"
#include "auxfd.h"

//   
//  iTBL[i] = atan(1./pow(2,i)) * (1 << i) * 0x40000000
extern int _iTBL[42];

#ifdef __cplusplus
extern "C" {
#endif

// atan2f(x, y) --
//
//    
//   ,   x/y,   [-Pi, Pi]
//
//    --.
//    CORDIC,    
float atan2f (float f1, float f2){

    int Mnt1;              //    
	int Exp1, Sgn1, Spc1;  //  ,   -    
    int Mnt2;              //    
	int Exp2, Sgn2, Spc2;  //  ,   -  
	int NewExp;            //   
	int Sgn=0;             //   
    int x, y;              //    
    int t;                 //       
    int atan;              //      
	int i;                 //     
    int j;                 //  ,    
	int rez = 0;           //   
	int iMj, iPj;          //      i-j, i+j

    //      
	DestructFloat( f1, Mnt1, Exp1, Sgn1, Spc1 );

    //    
    DestructFloat( f2, Mnt2, Exp2, Sgn2, Spc2 );

	//  
	if ( Exp1 == 0x80 ){
		if (Exp2 == 0x80 || Mnt1)
			return ConstructFloat( 1, 0x80, 0, 0);	//NAN
		else {
			Mnt1 = 0x00800000;                      //  atan2(+inf, c)
			Mnt2 = 0x00000000;
		}
	}
	else if (Exp2 == 0x80){
		if (Mnt2)
			return ConstructFloat( 1, 0x80, 0, 0);	//NAN
		else {
			Mnt1 = 0x00000000;                      //  atan2(c, +inf)
			Mnt2 = 0x00800000;
		}
	}
	if (Exp1 == -0x7f){
		if(Mnt1)
			Exp1++;
		else if (Exp2 == -0x7f && !Mnt2){
			_FPIEEE_Signal( _FPIEEE_TLoss );
			return 0;
		}
	}
	if (Exp2 == -0x7f){
		if(Mnt2)
			Exp2++;
	}

    //      
	Mnt1 <<= 5;
	Mnt2 <<= 5;

    //      ( )
	if (Exp1>Exp2){
		Mnt2 >>= Exp1 - Exp2;
		NewExp = 0;
	}
	else{
		if (Sgn2){
			Mnt1 >>= Exp2 - Exp1;
			NewExp = 0;
		}
		else{
			NewExp = Exp1 - Exp2;
		}
	}

	if (NewExp<-13)
		return f1/f2;

	//     
	x = Mnt2;
	y = Mnt1;
	if (Sgn1)
		y= -y;
	if (Sgn2)
		x= -x;
	j=-NewExp;
	i=j;
	iPj = i + j;

    //    CORDIC,    .
	while (iPj<28){
		iMj = i - j;
		atan = _iTBL[i]>>iMj;
		iPj = i + j;
		t = x;						//  
		if ( y>0){
			x += y>>iPj;		//  
			y -= t>>iMj;
			rez -= atan;
		}
		else{
			x -= y>>iPj;		//  
			y += t>>iMj;
			rez += atan;
		}
		t = x;						//  
		if ( y>0){
			x += y>>iPj;		//  
			y -= t>>iMj;
			rez -= atan;
		}
		else{
			x -= y>>iPj;		//  
			y += t>>iMj;
			rez += atan;
		}
		i++;
	}
	while (iMj<28){		/*  ?  -  i<64-NewExp
						x  ,    (microsoft ++(r))	-
						    .*/
		iMj = i - j;
		atan = _iTBL[i]>>iMj;
		if ( y>0){
			y -= x>>iMj;		//  
			rez -= atan;
		}
		else{
			y += x>>iMj;		//  
			rez += atan;
		}
		if ( y>0){
			y -= x>>iMj;		//  
			rez -= atan;
		}
		else{
			y += x>>iMj;		//  
			rez += atan;
		}
		i++;
	}
	if (rez<0){
		rez = -rez;
	}
	else{
		Sgn =1;
	}
    //      
	NewExp++;
	if (rez!=0){
		while (!(rez & 0x40000000)){
			rez <<= 1;
			NewExp--;
		}
	}
	else
		NewExp = -0x7f;

	//     , ...  
	rez >>=6;
	//    ,  .
	rez = (rez>>1) + (rez & 1);

	if (rez == 0x01000000){	
		rez = 0;
		NewExp++;
	}
    //   float
	return ConstructFloat( rez, NewExp, Sgn, 0);		
}

#ifdef __cplusplus
}
#endif
