//////////////////////////////////////////////////////////////////////////////
//                                                                          //
//                              //
//                                                                          //
//                                               //
//                                           //
//                                                                          //
//                          ftoi64.asm                                      //
//                                                                          //
//        32          //
//       64 .                                //
// ConvFtoI64 -  float     .                  //        
//                                                                          //
//////////////////////////////////////////////////////////////////////////////

// : 
// : 02 ( 27.11.97 )
// : 
// :   2    .    
//   .    .

global ConvFtoI64 :label;


extern ARShift32    :label;
extern LShift64     :label;
extern FFrExp       :label;
extern FPIEEE_Signal :label;


import FPIEEE_FLAGS_DEF from rtmacro;

FPIEEE_FLAGS_DEF();


begin text

//=====  ConvFtoI64 ==========================
//       32 
//       64 
//  : gr7 -  float 
//  :     -   .
//                -  .
// :       PC,PSW
// : ar5,gr7
<ConvFtoI64>
    push ar6,gr6;
    push ar0,gr0;
    push ar1,gr1 with gr1 = gr7;    // gr1 - 
    push ar2,gr2;

    push ar1,gr1;
    call FFrExp;
    pop ar2,gr2 with gr7;       // gr2 - 
    gr0 = ar2;                  // gr0 - 

    if <>0 delayed skip Invalid;
    gr7 = 127;
    gr7 = 23
        with gr2 -= gr7;
//    if u< skip Zero
//        with gr1 = gr1 A>> 31;  //  
//    if >= skip L1
//        with gr2 -= gr7;
//    gr0 = not gr0 noflags;

    if u< skip Zero with gr2 -= gr7;
    if u>= delayed skip Large;
    ar5 = gr1 with //	   PreAbnormal-a
			gr1 = gr1 A>> 31;  //  
	nul;
    // skip Large;

<L1>
//    if u>= skip Large;
//	:     ,  
//	  __ 

    delayed call ARShift32;
    push gr0 with gr2 = -gr2;   //    
    push gr2;
    // call ARShift32;

    pop ar2,gr2;
    ar5 = gr1 with gr7 = gr7 xor gr1;   // ar5 = ResHi; -x = not(x) +1
    pop ar1,gr1 with gr7 -= gr1;		//				-x = not(x) +1
    pop ar0,gr0;
    pop ar6,gr6;

    delayed return;
    push gr7;                   // push ResLo
    push ar5;                   // push ResHi
    nul;        // not executed
    // return;

<Large>
    gr7 = 40 with gr0 = gr0 xor gr1;		//				-x = not(x) +1
    gr7 = ar5 with gr2 - gr7;
    if u>= skip PreInvalid with gr0 -= gr1;	//				-x = not(x) +1

        //      .
//	 -    if false delayed goto 0;	(   - .align ,
//	      )
.align;
    push gr0;
    push gr1;

    call LShift64
        with gr7 = gr2;

    pop ar1,gr1;                // ar1 - ResLo, gr1 = ResHi
    ar5 = ar1 with gr7 = gr1;   // ar5 = ResLo, gr7 = ResHi    

    pop ar2,gr2;
    pop ar1,gr1;
    pop ar0,gr0;
    pop ar6,gr6;

    delayed return;
    push ar5;
    push gr7;
    nul;        // executed
    // return;

<Zero>
    pop ar2,gr2 with gr7 = false;
    pop ar1,gr1;
    pop ar0,gr0;
    pop ar6,gr6;

    delayed return;
    push gr7;
    push gr7;
    nul;        // executed
    // return

<PreInvalid>
	gr0 = 0DF000000h;
	with gr0 - gr7;
	if <>0 delayed skip Invalid;
	ar5 = 80000000h;
    // cond. skip Abnormal
    //	 0x8000000000000000
    pop ar2,gr2 with gr7 = false;
    pop ar1,gr1;
    pop ar0,gr0;
    pop ar6,gr6;

    delayed return;
    push gr7;
    push ar5;
    nul;        // executed
    // return

<Invalid>
    delayed call FPIEEE_Signal;
    gr7 = _FPIEEE_Invalid;
    // call FPIEEE_Signal;
    pop ar2,gr2;
    pop ar1,gr1;
    pop ar0,gr0;
    pop ar6,gr6 with gr7 = true;
    delayed return;
    push gr7;	//	    
    push gr7;
    nul;        // executed
    // return

end text;

//////////////////////////////////////////////////////////////////////////////
//                                                                          //
//                        ftoi64.asm                              //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////
