//////////////////////////////////////////////////////////////////////////
//                                                                      //
// tanh.cpp -                                                           //
//                                                                      //
//                              //
//        .                          //
//                                                                      //
// Copyright (c) 2001 RC Module Inc.                                    //
//                                                                      //
//  :  ..                                                 //
//                                                                      //
//   $Revision:: 1     $      $Date:: 2/14/06 8:10p    $                //
//                                                                      //
//////////////////////////////////////////////////////////////////////////

#include "math.h"
#include "auxfd.h"

//  Ln(2) * 0x4000000000000000
const ULONG DTLN2=3196577161300663914;

#ifdef __cplusplus
extern "C" {
#endif

//           
extern LONG _MathLib_DK[27];

//      
extern LONG _MathLib_DAtanh[84];

//     
extern ULONG _DTLN[64];

//       (   double)
ULONG SrvExp2(ULONG& Arg, int i, int& NewExp);

//      
//  (  Exp(x)   Exp(-x)   )
ULONG SrvExp1(ULONG Arg, int i);

//       
inline ULONG _DivFix0x64(ULONG Dmoe, ULONG Dtel, int& NewExp);

// tanh --
//
//     
//
//    --.
//    CORDIC,    
double tanh(double f){

	LONG Mnt;               //   
	LONG y;                 //      
	int Exp, Sgn;           //     
	int NewExp=0;           //      
	int PlusExp;            //      
	ULONG iSinh;            //     
	ULONG iCosh;            //     
	ULONG Arg;              //   
	LONG sArg;              //     
	ULONG rez;              //   
	ULONG mines_rez;        //    
	
    //   double
	DstrDouble( f, Mnt, Exp, Sgn );

	//  
    if ( Exp ==0x400 && Mnt==0 )					//  4 NAN
		return f;
	if ( Exp > 9 ){			//     tanh(x) = 1
		return ConstructDouble( 0, 0, Sgn, 0);
	}
    if ( Exp < -27 )			//    
	    return f;			//	lim(x->0)(sh(x)) = x

	int i=-11;      //   

    //     () ,  floor 
	if (Exp>=0){				
		Arg = Mnt << (Exp);
	}
	else if (Exp>=-2){
		Arg = Mnt << 4;
		Arg = Arg >> (-Exp);
		i=-7;
	}
	else {
		Arg = Mnt << 11;
		Arg = Arg >> (-Exp);
		i=0;
	}

    rez = SrvExp2( Arg, i, NewExp);
    PlusExp = NewExp;
    iSinh = rez;
    iCosh = rez;
    if ( NewExp >31 ){          //  sh = exp(x)/2
	    if (NewExp>0x3ff){
    		return ConstructDouble( 0, 0, Sgn, 0);
	    }
    }
    else{                       // sh = (exp(x)-exp(-x))/2
    	Arg = DTLN2 - Arg;
        mines_rez = SrvExp1(Arg, 0);
        iSinh -= mines_rez >> ((NewExp<<1)+1);
        iCosh += mines_rez >> ((NewExp<<1)+1);
    }
    NewExp=0;
    if(Exp<0){
        //      
        sArg = Mnt << 9;

        NewExp = Exp+1;

	    y = 0; 
        LONG x = _MathLib_DK[-NewExp];
	    LONG x1=x;

        int i = 1-NewExp;
        int k=i;

        const int iMax = 62;

        for (; i<iMax+NewExp;){
	        for (; i<k; i++){
		        if (sArg >= 0){
			        x1 += y >> (i-NewExp);
			        y += x >> (i+NewExp);
			        sArg = (sArg - _MathLib_DAtanh[i])<<1;
		        }
		        else{
			        x1 -= y >> (i-NewExp);
			        y -= x >> (i+NewExp);
			        sArg = (sArg + _MathLib_DAtanh[i])<<1;
		        }
		        x = x1;
	        }
            {
		        if (sArg >= 0){
			        x1 += y >> (i-NewExp);
			        y += x >> (i+NewExp);
			        sArg -= _MathLib_DAtanh[i];
		        }
		        else{
			        x1 -= y >> (i-NewExp);
			        y -= x >> (i+NewExp);
			        sArg += _MathLib_DAtanh[i];
		        }
		        x = x1;
            }
            k = (k<<1)+k+1;
            if (k>iMax+NewExp)
                k = iMax+NewExp;
	    }
	    while (i<iMax-NewExp){  /*  ?  -  i<64-NewExp
						x  ,    (microsoft ++(r))	-
						    .*/
		    if (sArg >= 0){
			    y += x >> (i+NewExp);
			    sArg = (sArg - _MathLib_DAtanh[i++])<<1;
		    }
		    else{
			    y -= x >> (i+NewExp);
			    sArg = (sArg + _MathLib_DAtanh[i++])<<1;
		    }
		    x = x1;
	    }
        NewExp+=2-PlusExp;
        iSinh = y;
    }
    y = _DivFix0x64( iSinh, iCosh, NewExp);
	if (y!=0){
		while (!(y & 0x4000000000000000)){
			y <<= 1;
			NewExp--;
		}
	}
	else
		NewExp = -0x3ff;

	y >>=9;	                //    , ...
	y = (y>>1) + (y & 1);   //   ,  .

    if (y & 0x0020000000000000){	
	    y >>= 1;
	    NewExp++;
    }

    //   double
    return ConstructDouble( y, NewExp, Sgn, 0);	
}

#ifdef __cplusplus
}
#endif

//       
inline ULONG _DivFix0x64(ULONG Dmoe, ULONG Dtel, int& NewExp){
	LONG rez=0, tmp;
	int i=0;
	while (Dtel<=Dmoe){
		NewExp++;
		Dtel<<=1;
	}
	NewExp--;
	Dtel>>=1;
	while(i<62){
		tmp = Dmoe;
		tmp -= Dtel;
		if (tmp>=0){
			Dmoe = tmp;
			rez++;
		}
		Dmoe<<=1;
		rez<<=1;
		i++;
	}
	return rez;
}

//       (   double)
ULONG SrvExp2(ULONG& Arg, int i, int& NewExp){
    LONG tmp = Arg;
    ULONG RetArg;
	ULONG rez = 0x4000000000000000; 

	while (i<0){    //  
		i++;
		tmp -= DTLN2; 
		if (tmp>0){
			Arg = tmp;
			NewExp += 1 << (-i);
		}
		else        //    - 
			tmp = Arg;
		tmp <<=1;
		Arg = tmp;
	}
	tmp >>=1;
	Arg = tmp;
    RetArg = Arg;
    while (i!=62){  //  
		tmp -= _DTLN[i++];  //    ,
                            //    ,  _DTLN[]
                            //  ,    
		if (tmp>0){
			rez += rez >> i; //  - !
			Arg = tmp;
		}
		else //    - 
			tmp = Arg;
	}
    Arg = RetArg;
    return rez;
}

//      
//  (  Exp(x)   Exp(-x)   )
ULONG SrvExp1(ULONG Arg, int i){
	LONG tmp = Arg; //       
	ULONG rez = 0x4000000000000000; 

    while (i!=62){  //  
		tmp -= _DTLN[i++];  //    ,
                            //    ,  _DTLN[]
                            //  ,    
		if (tmp>0){
			rez += rez >> i; //  - !
			Arg = tmp;
		}
		else //    - 
			tmp = Arg;
	}
    return rez;
}
